<?php

// Enable error reporting;
//error_reporting(E_ALL);
include 'db.php';

// Tie in with Cacti authentication
//chdir("../../");
//include_once("./include/auth.php");

/*
 * Edit variables here for directories and output files etc, nothing else should need editing;
 */

// Full path to rrdtool binary
$rrdtool="/usr/bin/rrdtool";

// Temp file used for rrdtools output, calculating bandwidth and throughput
// Typically the place where the GraphExport pages are unpacked, <cacti-site-root>/plugins/GraphExport
$rrdtmpfile="/opt/cacti/plugins/GraphExport/rrd_values";

// Temp folder for dumping graphs into
$tmpfolder="/opt/cacti/plugins/GraphExport/tmp";

// The root URL to this Cacti webserver
$rooturl="http://192.168.30.124/cacti";

// The relative http path to the temp folder so they can accessed by a browser
$httptmp="plugins/GraphExport/tmp";

/*
 * End of variables
 */

// Function to generate random string for graph names,
// This is the answer for a StackExchange post, answer by Stephen Watkins,
// Many thanks to him, nice succinct answer:
// http://stackoverflow.com/questions/4356289/php-random-string-generator
function generateRandomString($length = 10) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $randomString = '';
    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[rand(0, strlen($characters) - 1)];
    }
    return $randomString;
}

// On with the show!...

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>

<title>Cacti Graph Exporter</title>

<script type="text/javascript">
//<![CDATA[

  // Lets write a load of JavaScript to grab the current time and some other time values,
  // and pre-populate the date/time to/from boxes etc...Ugliness ensues...

 if(!window.dDate) window.dDate = new Date();

 function genEpoch() {
  var year = parseInt(document.getElementById("startepochyear").value);
  var month = parseInt(document.getElementById("startepochmonth").value)-1; // Epoch months are 0-11
  var day = parseInt(document.getElementById("startepochday").value);
  var hour = parseInt(document.getElementById("startepochhour").value);
  var minute = parseInt(document.getElementById("startepochminute").value);
  var second = parseInt(document.getElementById("startepochsecond").value);
  var millis = 0;
  //dDate.setFullYear(year, month, day);
  //dDate.setHours(hour, minute, second, millis);
  dDate = new Date(Date.UTC(year,month,day,hour,minute,second,millis));
  if (document.getElementById("adjustgmt").checked == true) {
    document.getElementById("startepoch").value = parseInt((dDate.getTime()/1000) + (new Date().getTimezoneOffset()*60));
  } else {
    document.getElementById("startepoch").value = parseInt(dDate.getTime()/1000);
  }

  year = parseInt(document.getElementById("endepochyear").value);
  month = parseInt(document.getElementById("endepochmonth").value)-1; // Epoch months are 0-11
  day = parseInt(document.getElementById("endepochday").value);
  hour = parseInt(document.getElementById("endepochhour").value);
  minute = parseInt(document.getElementById("endepochminute").value);
  second = parseInt(document.getElementById("endepochsecond").value);
  millis = 0;
  //dDate.setFullYear(year, month, day);
  //dDate.setHours(hour, minute, second, millis);
  dDate = new Date(Date.UTC(year,month,day,hour,minute,second,millis));
  if (document.getElementById("adjustgmt").checked == true) {
    document.getElementById("endepoch").value = parseInt((dDate.getTime()/1000) + (new Date().getTimezoneOffset()*60));
  } else {
    document.getElementById("endepoch").value = parseInt(dDate.getTime()/1000);
  }

  year = parseInt(document.getElementById("startreportyear").value);
  month = parseInt(document.getElementById("startreportmonth").value)-1; // Epoch months are 0-11
  day = 1;
  hour = 0;
  minute = 0;
  second = 0;
  millis = 0;
  //dDate.setFullYear(year, month, day);
  //dDate.setHours(hour, minute, second, millis);
  dDate = new Date(Date.UTC(year,month,day,hour,minute,second,millis));
  if (document.getElementById("adjustgmt").checked == true) {
    document.getElementById("monthlystartepoch").value = parseInt((dDate.getTime()/1000) + (new Date().getTimezoneOffset()*60));
  } else {
    document.getElementById("monthlystartepoch").value = parseInt(dDate.getTime()/1000);
  }

  year =  parseInt(document.getElementById("endreportyear").value);
  month = parseInt(document.getElementById("endreportmonth").value); // No -1 here because day == 0 below
  day = 0;
  hour = 23;
  minute = 55;
  second = 00;
  millis = 000;
  //dDate.setFullYear(year, month, day);
  //dDate.setHours(hour, minute, second, millis);
  dDate = new Date(Date.UTC(year,month,day,hour,minute,second,millis));
  if (document.getElementById("adjustgmt").checked == true) {
    document.getElementById("monthlyendepoch").value = parseInt((dDate.getTime()/1000) + (new Date().getTimezoneOffset()*60));
  } else {
    document.getElementById("monthlyendepoch").value = parseInt(dDate.getTime()/1000);
  }

 }

 function changeType() {
  document.getElementById("hostid").selectedIndex=0;
  document.getElementById("hostname").value = '';
  document.getElementById("graphname").value = '';
  document.getElementById("sourcename").value = '';
  // clear the graphs list
  var graphList = document.getElementById("graphid");
  for (var count = graphList.options.length-1; count >-1; count--) {
   graphList.options[count] = null;
  }
  // clear the sources list
  var sourceList = document.getElementById("sourceid");
  for (var count = sourceList.options.length-1; count >-1; count--) {
   sourceList.options[count] = null;
  }
 }

 function changeHost() {
  if (document.getElementById("hostid").value>0) {
   // Store the selected host name
   var listIndex = document.getElementById("hostid").selectedIndex;
   document.getElementById("hostname").value = document.getElementById("hostid").options[listIndex].text;
   document.getElementById("graphname").value = '';
   document.getElementById("sourcename").value = '';
   // clear the graphs list
   var graphList = document.getElementById("graphid");
   for (var count = graphList.options.length-1; count >-1; count--) {
    graphList.options[count] = null;
   }
   // clear the sources list
   var sourceList = document.getElementById("sourceid");
   for (var count = sourceList.options.length-1; count >-1; count--) {
    sourceList.options[count] = null;
   }
   document.getElementById("graphDates").innerHTML = '';
   var requestUrl;
   requestUrl = "ajax.php?action=get_hostid_graphs&hostid="+document.getElementById("hostid").value+"&hosttype="+
   document.getElementById("hosttype").value;
   CreateXmlHttpObj("hostgraphs");
   // verify XmlHttpObj variable was successfully initialized
   if(XmlHttpObjHostGraphs)  {
    // assign the StateChangeHandler function ( defined below in this file)
    // to be called when the state of the XmlHttpObj changes
    // receiving data back from the server is one such change
    XmlHttpObjHostGraphs.onreadystatechange = StateChangeHandler;
    // define the interaction with the server -- true for as asynchronous.
    XmlHttpObjHostGraphs.open("GET", requestUrl,  true);
    // send request to server, null arg  when using "GET"
    XmlHttpObjHostGraphs.send(null);		
   }
  }
 }

 function changeGraph() {
  if (document.getElementById("graphid").value>0) {
   var listIndex = document.getElementById("graphid").selectedIndex;
   document.getElementById("graphname").value = document.getElementById("graphid").options[listIndex].text;
   var sourceList = document.getElementById("sourceid");
   for (var count = sourceList.options.length-1; count >-1; count--) {
    sourceList.options[count] = null;
   }
   document.getElementById("graphDates").innerHTML = '';
   var requestUrl;
   requestUrl = "ajax.php?action=get_graphid_source_name&hostid="+document.getElementById("hostid").value+
     "&graphid="+document.getElementById("graphid").value;
   CreateXmlHttpObj("graphsource");
    if(XmlHttpObjGraphSource)  {
      XmlHttpObjGraphSource.onreadystatechange = StateChangeHandler;
      XmlHttpObjGraphSource.open("GET", requestUrl,  true);
      XmlHttpObjGraphSource.send(null);
    }
  }
 }

 function changeSource() {
  if (document.getElementById("sourceid").value>0) {
   var listIndex = document.getElementById("sourceid").selectedIndex;
   var sourceID = document.getElementById("sourceid").options[listIndex].value;
   var requestUrl = "ajax.php?action=get_graphid_dates&hostid="+document.getElementById("hostid").value+
                    "&sourceid="+sourceID;
   CreateXmlHttpObj("graphdates");
   if(XmlHttpObjGraphDates)  {
     XmlHttpObjGraphDates.onreadystatechange = StateChangeHandler;
     XmlHttpObjGraphDates.open("GET", requestUrl,  true);
     XmlHttpObjGraphDates.send(null);
   }
  } 
 }


 function CreateXmlHttpObj(reason) {
  if (reason=="hostgraphs") {
   try { // try creating for IE (note: we don't know the user's browser type here, just attempting IE first.)
     XmlHttpObjHostGraphs = new ActiveXObject("Msxml2.XMLHTTP");
   }
   catch(e) {
    try  {
      XmlHttpObjHostGraphs = new ActiveXObject("Microsoft.XMLHTTP");
    } 
    catch(oc)  {
      XmlHttpObjHostGraphs = null;
    }
   }
   // if unable to create using IE specific code then try creating for Mozilla (FireFox) 
   if(!XmlHttpObjHostGraphs && typeof XMLHttpRequest != "undefined")  {
     XmlHttpObjHostGraphs = new XMLHttpRequest();
   }
  } else if (reason=="graphsource") {
   try { 
     XmlHttpObjGraphSource = new ActiveXObject("Msxml2.XMLHTTP");
   }
   catch(e) {
    try  {
      XmlHttpObjGraphSource = new ActiveXObject("Microsoft.XMLHTTP");
    }
    catch(oc)  {
      XmlHttpObjGraphSource = null;
    }
   }
   if(!XmlHttpObjGraphSource && typeof XMLHttpRequest != "undefined")  {
     XmlHttpObjGraphSource = new XMLHttpRequest();
   }
  } else if (reason=="graphdates") {
   try {
     XmlHttpObjGraphDates = new ActiveXObject("Msxml2.XMLHTTP");
   }
   catch(e) {
    try  {
      XmlHttpObjGraphDates = new ActiveXObject("Microsoft.XMLHTTP");
    }
    catch(oc)  {
      XmlHttpObjGraphDates = null;
    }
   }
   if(!XmlHttpObjGraphDates && typeof XMLHttpRequest != "undefined")  {
     XmlHttpObjGraphDates = new XMLHttpRequest();
   }
  }
 }

 // This function is called when state of XmlHttpObj changes,
 // we're interested in the state that indicates data has been
 // received from the server
 function StateChangeHandler() {
  if(typeof(XmlHttpObjHostGraphs) !== 'undefined') { 
   // state ==4 indicates receiving response data from server is completed
   if(XmlHttpObjHostGraphs.readyState == 4) {
    // To make sure valid response is received from the server, 200 means response received is OK
    if(XmlHttpObjHostGraphs.status == 200)  {			
     PopulateGraphList(XmlHttpObjHostGraphs.responseXML.documentElement);
     delete XmlHttpObjHostGraphs;
    } else {
     alert("Problem retrieving host graph data from the server, status code: "  + XmlHttpObjHostGraphs.status);
    }
   }
  }
  if(typeof(XmlHttpObjGraphSource) !== 'undefined') {
   if(XmlHttpObjGraphSource.readyState == 4) {
    if(XmlHttpObjGraphSource.status == 200)  {
     PopulateGraphSourceList(XmlHttpObjGraphSource.responseXML.documentElement);
     delete XmlHttpObjGraphSource;
    } else {
     alert("Problem retrieving graph source data from the server, status code: "  + XmlHttpObjGraphsSource.status);
    }
   }
  }
  if(typeof(XmlHttpObjGraphDates) !== 'undefined') {
   if(XmlHttpObjGraphDates.readyState == 4) {
    if(XmlHttpObjGraphDates.status == 200)  {
     PopulateGraphDatesDiv(XmlHttpObjGraphDates.responseXML.documentElement);
     delete XmlHttpObjGraphDates;
    } else {
     alert("Problem retrieving graph dates data from the server, status code: "  + XmlHttpObjGraphDates.status);
    }
   }
  }
 }

 // populate the contents of the host graph dropdown list
 function PopulateGraphList(graphIDXML) {
  var graphList = document.getElementById("graphid");
  // clear the list 
  for (var count = graphList.options.length-1; count >-1; count--) {
    graphList.options[count] = null;
  }
  var graphIDs = graphIDXML.getElementsByTagName('graph');
  var idValue;
  var textValue; 
  var optionItem;
  // populate the dropdown list with data from the xml doc
  for (var count = 0; count < graphIDs.length; count++) {
   textValue = GetInnerText(graphIDs[count]);
   idValue = graphIDs[count].getAttribute("id");
   optionItem = new Option(textValue, idValue,  false, false);
   graphList.options[graphList.length] = optionItem;
  }
 }

 // populate the contents of the graph source dropdown list
 function PopulateGraphSourceList(sourceIDXML) {
  var sourceList = document.getElementById("sourceid");
  for (var count = sourceList.options.length-1; count >-1; count--) {
    sourceList.options[count] = null;
  }
  var sourceIDs = sourceIDXML.getElementsByTagName('source');
  var idValue;
  var textValue;
  var optionItem;
  for (var count = 0; count < sourceIDs.length; count++) {
   textValue = GetInnerText(sourceIDs[count]);
   idValue = sourceIDs[count].getAttribute("id");
   optionItem = new Option(textValue, idValue,  false, false);
   sourceList.options[sourceList.length] = optionItem;
  }
 }

 // populate the contents of the graph dates div element
 function PopulateGraphDatesDiv(sourceIDXML) {
  var graphDates = document.getElementById("graphDates");
  graphDates.innerHTML = '';
  var dateIDs = sourceIDXML.getElementsByTagName('date');
  graphDates.innerHTML = "First RRD sample: " + GetInnerText(dateIDs[0]) + ". Last RRD sample: " + GetInnerText(dateIDs[1]) + ".";
 }

 // returns the node text value 
 function GetInnerText (node) {
  return (node.textContent || node.innerText || node.text) ;
 }

 function toggleDebug(preid) {
  var pre = document.getElementById(preid);
  if (pre.style.display=='none') {
   pre.style.display = 'block';
  } else {
   pre.style.display = 'none';
  }
 }

 function selectItemByValue(elmnt, value) {
  for(var i=0; i < elmnt.options.length; i++) {
   if(elmnt.options[i].value == value) {
    elmnt.selectedIndex = i;
    return;
   }
  }
 }

//]]>
</script>

<style type="text/css">
body {font-family:verdana;}
</style>

</head>
<body onLoad="javascript:genEpoch()" style="font-size:medium; font-family:sans-serif;">

<div>
  <div>
  <form name="reportform" id="reportorm" method="post" action="index.php">
  <input type="hidden" name="action" id="action" value="report">

  <strong>Generate graphs for specific periods</strong><br><br>

  It is important to understand how Cacti gathers and records data to understand why data and graphs created with the GraphExport tool may be different from those displayed by Cacti itself or from other NMS systems like SolarWinds for example. Please read the <a href="README.txt">README</a>.<br><br>

  NOTE: All times are GMT+0, they will be one hour out during daylight saving periods!<br>
  Try to auto-convert GMT times to your timezone: <input type="checkbox" name="adjustgmt" id="adjustgmt" value="adjustgmt" checked onchange="javascript:genEpoch()"><br><br>

  <input type="radio" name="reportperiod" id="reportperiod" value="monthly" <? 
    if (isset($_POST['reportperiod']) && $_POST['reportperiod']=="monthly") { 
      echo ' checked>'; 
    } elseif (!isset($_POST['reportperiod'])) { 
      echo ' checked>';
    } else {
      echo '>'; 
    } 
  ?>
  Month by month report (from first day of the month @ 00:00:00 till last day of month @ 23:55:00)<br>
  Choose starting month and year:
  <select name="startreportmonth" id="startreportmonth" onchange="javascript:genEpoch()">
  <? $lastmonth = date("n", strtotime("-1 month"));
    for ($m=1;$m<=12;$m++) {
    if ($m<10) { echo '  <option value="0'.$m.'"'; } else { echo '  <option value="'.$m.'"'; }
    if (isset($_POST['startreportmonth']) && $_POST['startreportmonth']!="") {
      if ($m==$_POST['startreportmonth']) { echo ' selected'; }
    } else {
        if ($m==$lastmonth) { echo ' selected'; }
    }
    echo ">".$m."</option>\n";
  } ?>
  </select>
  <select name="startreportyear" id="startreportyear" onchange="javascript:genEpoch()">
  <? $lastyear = date("Y", strtotime("-1 month"));
    for ($y=2001;$y<=date("Y");$y++) {
    echo '  <option value="'.$y.'"';
    if (isset($_POST['startreportyear']) && $_POST['startreportyear']!="") {
      if ($y==$_POST['startreportyear']) { echo ' selected'; }
    } else {
      if ($y==$lastyear) { echo ' selected'; }
    }
    echo ">".$y."</option>\n";
  } ?>
  </select>
  <input type="text" name="monthlystartepoch" id="monthlystartepoch" />
  </br>

  Choose ending month and year:
  <select name="endreportmonth" id="endreportmonth" onchange="javascript:genEpoch()">
  <? for ($m=1;$m<=12;$m++) {
    if ($m<10) { echo '  <option value="0'.$m.'"'; } else { echo '  <option value="'.$m.'"'; }
    if (isset($_POST['endreportmonth']) && $_POST['endreportmonth']!="") {
      if ($m==$_POST['endreportmonth']) { echo ' selected';}
    } else {
      if ($m==date("n")) { echo ' selected'; }
    }
    echo ">".$m."</option>\n";
  } ?>
  </select>
  <select name="endreportyear" id="endreportyear" onchange="javascript:genEpoch()">
  <? for ($y=2001;$y<=date("Y");$y++) {
    echo '  <option value="'.$y.'"';
    if(isset($_POST['endreportyear']) && $_POST['endreportyear']!="") {
      if ($y==$_POST['endreportyear']) { echo ' selected'; }
    } else {
      if ($y==date("Y")) { echo ' selected'; }
    }
    echo ">".$y."</option>\n";
  } ?>
  </select>
  <input type="text" name="monthlyendepoch" id="monthlyendepoch" />
  </br></br>

  <input type="radio" name="reportperiod" id="reportperiod" value="customepoch" <?
   if (isset($_POST['reportperiod']) && $_POST['reportperiod']=="customepoch") { echo ' checked>'; } else { echo '>'; } ?>
  Specifc epoch start and end date/time <br>
  <input type="text" id="startepoch" name="startepoch"/>
  <select name="startepochday" id="startepochday" onchange="javascript:genEpoch()">
  <? for ($d=1;$d<=31;$d++) {
    if ($d<10) { echo '  <option value="0'.$d.'"'; } else { echo '  <option value="'.$d.'"'; }
    if (isset($_POST['startepochday']) && $_POST['startepochday']!="") {
      if ($d==$_POST['startepochday']) { echo ' selected'; }
    } else {
      if ($d==date("d")) { echo ' selected'; }
    }
    echo ">".$d."</option>";
  } ?>
  </select>
  <select name="startepochmonth" id="startepochmonth" onchange="javascript:genEpoch()">
  <? $lastmonth = date("n", strtotime("-1 month"));
    for ($m=1;$m<=12;$m++) {
    if ($m<10) { echo '  <option value="0'.$m.'"'; } else { echo '  <option value="'.$m.'"'; }
    if (isset($_POST['startepochmonth']) && $_POST['startepochmonth']!="") {
      if ($m==$_POST['startepochmonth']) { echo ' selected'; }
    } else {
      if ($m==$lastmonth) { echo ' selected'; }
    }
    echo ">".$m."</option>\n";
  } ?>
  </select>
  <select name="startepochyear" id="startepochyear" onchange="javascript:genEpoch()">
  <? $lastyear = date("Y", strtotime("-1 month"));
    for ($y=2001;$y<=date("Y");$y++) {
    echo '  <option value="'.$y.'"';
    if (isset($_POST['startepochyear']) && $_POST['startepochyear']!="") {
      if ($y==$_POST['startepochyear']) { echo ' selected'; }
    } else {
      if ($y==$lastyear) { echo ' selected'; }
    } 
    echo ">".$y."</option>\n";
  } ?>
  </select>
  <input type="text" name="startepochhour" id="startepochhour" value="<?
  if (isset($_POST['startepochhour']) && $_POST['startepochhour']!="") {
    echo $_POST['startepochhour'];
  } else {
    echo '00';
  }
  ?>" style="width:25px" onkeyup="javascript:genEpoch()"/> :
  <input type="text" name="startepochminute" id="startepochminute" value="<?
  if (isset($_POST['startepochminute']) && $_POST['startepochminute']!="") {
    echo $_POST['startepochminute'];
  } else {
    echo '00';
  }
  ?>" style="width:25px" onkeyup="javascript:genEpoch()"/> :
  <input type="text" name="startepochsecond" id="startepochsecond" value="<?
  if (isset($_POST['startepochsecond']) && $_POST['startepochsecond']!="") {
    echo $_POST['startepochsecond'];
  } else {
    echo '00';
  }
  ?>" style="width:25px" onkeyup="javascript:genEpoch()"/>
  </br>

  <input type="text" id="endepoch" name="endepoch"/>
  <select name="endepochday" id="endepochday" onchange="javascript:genEpoch()">
  <? for ($d=1;$d<=31;$d++) {
    if ($d<10) { echo '  <option value="0'.$d.'"'; } else { echo '  <option value="'.$d.'"'; }
    if (isset($_POST['endepochday']) && $_POST['endepochday']!="") {
      if ($d==$_POST['endepochday']) { echo ' selected'; }
    } else {
      if ($d==date("d")) { echo ' selected'; }
    }

    echo ">".$d."</option>";
  } ?>
  </select>
  <select name="endepochmonth" id="endepochmonth" onchange="javascript:genEpoch()">
  <? for ($m=1;$m<=12;$m++) {
    if ($m<10) { echo '  <option value="0'.$m.'"'; } else { echo '  <option value="'.$m.'"'; }
    if (isset($_POST['endepochmonth']) && $_POST['endepochmonth']!="") {
      if ($m==$_POST['endepochmonth']) { echo ' selected'; }
    } else {
      if ($m==$lastmonth) { echo ' selected'; }
    }
    echo ">".$m."</option>\n";
  } ?>
  </select>
  <select name="endepochyear" id="endepochyear" onchange="javascript:genEpoch()">
  <? for ($y=2001;$y<=date("Y");$y++) {
    echo '  <option value="'.$y.'"';
    if (isset($_POST['endepochyear']) && $_POST['endepochyear']!="") {
      if ($y==$_POST['endepochyear']) { echo ' selected'; }
    } else {
      if ($y==$lastyear) { echo ' selected'; }
    }
    echo ">".$y."</option>\n";
  } ?>
  </select>
  <input type="text" name="endepochhour" id="endepochhour" value="<?
  if (isset($_POST['endepochhour']) && $_POST['endepochhour']!="") {
    echo $_POST['endepochhour'];
  } else {
    echo '23';
  }
  ?>" style="width:25px" onkeyup="javascript:genEpoch()"/> :
  <input type="text" name="endepochminute" id="endepochminute" value="<?
  if (isset($_POST['endepochminute']) && $_POST['endepochminute']!="") {
    echo $_POST['endepochminute'];
  } else {
    echo '55';
  }
  ?>" style="width:25px" onkeyup="javascript:genEpoch()"/> :
  <input type="text" name="endepochsecond" id="endepochsecond" value="<?
  if (isset($_POST['endepochsecond']) && $_POST['endepochsecond']!="") {
    echo $_POST['endepochsecond'];
  } else {
    echo '00';
  }
  ?>" style="width:25px" onkeyup="javascript:genEpoch()"/>
  </br>
  </br>

  Format graph titles for:
  </br>
  <input type="radio" name="graphformat" id="graphformat" value="internal" <?
    if (isset($_POST['graphformat']) && $_POST['graphformat']=="internal") {
      echo ' checked>';
    } elseif (!isset($_POST['graphformat'])) {
      echo ' checked>';
    } else {
      echo '>';
    }
  ?> internal usage (show all details)
  </br>
  <input type="radio" name="graphformat" id="graphformat" value="external1" <?
   if (isset($_POST['graphformat']) && $_POST['graphformat']=="external1") { echo ' checked>'; } else { echo '>'; } ?>
  external usage 1 (strip details from graph titles)
  </br>
  <input type="radio" name="graphformat" id="graphformat" value="external2" <?
   if (isset($_POST['graphformat']) && $_POST['graphformat']=="external2") { echo ' checked>'; } else { echo '>'; } ?>
  external usage 2 (Show port name)


  </br></br>
 
  <input type="hidden" name="hostname" id="hostname" value="">
  <input type="hidden" name="graphname" id="graphname" value="">
  <input type="hidden" name="sourcename" id="sourcename" value="">

  Host Type: <select name="hosttype" id="hosttype" onchange="javascript:changeType();">
  <option value="cisco"<?
  if (isset($_POST['hosttype']) && $_POST['hosttype']!="") {
    if ($_POST['hosttype']=="cisco") { echo " selected"; }
  } else { echo " selected"; } ?>>Cisco</option>
  <option value="m0n0wall"<?
  if (isset($_POST['hosttype']) && $_POST['hosttype']!="") {
    if ($_POST['hosttype']=="m0n0wall") { echo " selected"; }
  } ?>>m0n0wall</option>
  </select></br>

  <?
  // Query for Cacti tree names and IDs
  $query = "SELECT id, description, hostname FROM `host` ORDER BY description";
  $db = mysql_select_db("cacti");
  $result = mysql_query($query);
  if(!$result) {
    die("Couldn't get list of hosts: ".mysql_error());
  }

  echo "Select Host: <select name=\"hostid\" id=\"hostid\" onchange=\"javascript:changeHost();\">\n";
  echo "  <option value=\"\" selected></option>\n";
  while ($row=mysql_fetch_assoc($result)) {
    echo "  <option value=\"".$row['id']."\">".$row['description']." | ".$row['hostname']."</option> \n";
  }

  echo '  </select>';
  ?>

  </br>
  Select graph: <select name="graphid" id="graphid" onchange="javascript:changeGraph();">
  </select>

  </br>
  Select graph source: <select name="sourceid" id="sourceid" onchange="javascript:changeSource();">
  </select>
  <div name="graphDates" id="graphDates" style="font-size:small;"></div>
  </br>

  <input type="submit" value="generate"></br>

<? if(isset($_POST['hostid']) && isset($_POST['graphid']) && isset($_POST['sourceid']) &&
     $_POST['hostid']!="" && $_POST['graphid']!="" && $_POST['sourceid']!="") {

echo "  <script type=\"text/javascript\"> 
    var ddl = document.getElementById('hostid');
    selectItemByValue(ddl, ".$_POST['hostid'].");
    changeHost();
    setTimeout(function() { chooseGraph(); }, 1000);
    setTimeout(function() { adjustGMT(); }, 1000);
    setTimeout(function() { genEpoch(); }, 1000);

    function chooseGraph() {
      var ddl = document.getElementById('graphid');
      selectItemByValue(ddl, ".$_POST['graphid'].");
      changeGraph();
      setTimeout(function() { chooseSource(); }, 1000);
    }

    function chooseSource() {
      var ddl = document.getElementById('sourceid');
      selectItemByValue(ddl, ".$_POST['sourceid'].");
    }

    function adjustGMT() {
      var ddl = document.getElementById('adjustgmt');
      ";
      if (isset($_POST['adjustgmt'])) {
        echo 'ddl.checked = true;';
      } else {
        echo 'ddl.checked = false;';
      }
      echo "
    }
  </script>\n";
} ?>

  </br>
  </form>

</div>

<div>
<?

function genMax($start,$end,$rrd) {
    global $rrdtool, $rrdtmpfile, $tmpfolder, $rooturl, $httptmp;

    /*
     * We actually need to -1 second from the start and end times passed to rrdtool.
     * E.g.: 1498867200 is Saturday, 1 July 2017 00:00:00 (GMT)
     * rrdtool will actually start from 1498867500 (+300 seconds) which is Saturday, 1 July 2017 00:05:00 (GMT)
     * It seems to be rounding up to the nearest 5 minute sample, starting from 0.
     * Equally asking rrdtool to end at 1501545299 which is Monday, 31 July 2017 23:55:00 (GMT)
     * will be rounded up (because it is zero or more second after the nearest 5 minute boundry)
     * to 1501545600 which is Tuesday, 1 August 2017 00:00:00 (GMT) and the first sample of the next month.
     */

    $cmdstart = $start - 1;
    $cmdend = $end - 1;

    // Blank out a file and dump this months values from rrd file
    exec("echo \"\" > $rrdtmpfile");
    exec("$rrdtool fetch -s $cmdstart -e $cmdend $rrd MAX > $rrdtmpfile");
    exec("sed -i 1,+1d $rrdtmpfile");
    // remove the titles from the rrd output
    // Blank out a new file for sorting into max values
    exec("echo \"\" > $rrdtmpfile"."_max");
    // Open file for writing
    $handle_in = fopen("$rrdtmpfile", "r");
    $handle_out = fopen("$rrdtmpfile"."_max", "w");
    $lastin = 0.0;
    $innow = 0;
    $lastout = 0.0;
    $outnow = 0;
    $average = 0;
    $samples = 0;

    while(!feof($handle_in)) {
      $line = fgets($handle_in);
      $values = explode(" ", $line);

      if($values[1]=="nan") {
        $innow = $lastin;
      } else {
        $innow = sprintf("%f", $values[1]);
        $lastin = $innow;
      }
      if($values[2]=="nan") {
        $outnow = $lastout;
      } else {
        $outnow = sprintf("%f", $values[2]);
        $lastout = $outnow;
      }
      if($innow >= $outnow) {
        fwrite($handle_out, $innow."\n");
        $average=$average+$innow;
      } else {
        fwrite($handle_out, $outnow."\n");
        $average=$average+$outnow;
      }
      $samples=$samples+1;
    }
    fclose($handle_in);
    fclose($handle_out);

    //Calculate an average
    $average=$average/$samples;

    // Now we have filled ./rrd_values_max with the highest value from each time period,
    // sort them in desending order
    exec("sort -g -r $rrdtmpfile"."_max > $rrdtmpfile"."_max_sorted");
    // Remove any blank lines (typically one on the end)
    exec("sed '/^$/d' $rrdtmpfile"."_max_sorted > $rrdtmpfile"."_max_sorted_trim");
    // Get the highest/max value from the first line of the file
    $max = shell_exec("head -n 1 $rrdtmpfile"."_max_sorted_trim");
    // Ge the lowest/minimum value from the last line of the file
    $min = shell_exec("tail -n 1 $rrdtmpfile"."_max_sorted_trim");
    // Count the number of lines of rrd values
    $linecount = shell_exec("grep -c ^ $rrdtmpfile"."_max_sorted_trim");
    // Get 5 percent of the line count value, round it down with floor()
    $fivepc = floor(($linecount/100)*5);
    // Now read the value from the line, 5% down from the top of the line count of the file
    $ninetyfifth = shell_exec("awk -v n1=$fivepc 'NR==n1' $rrdtmpfile"."_max_sorted_trim");
    $ninetyfifth = trim($ninetyfifth);
    // Round it up
    //$ninetyfifth = ceil($ninetyfifth);
    // Convert to bps,kbps,mbps
    $ninetyfifthbps = ceil(($ninetyfifth*8));
    $ninetyfifthkbps = round(($ninetyfifthbps/1000), 2);
    $ninetyfifthmbps = round(($ninetyfifthkbps/1000), 2);

    if (isset($_POST['graphformat']) && $_POST['graphformat']=="internal") {
      $array=explode("|", $_POST['hostname'], 2);
      $graphtitle = trim($array[0])." - ".$_POST['graphname'];
      $graphname = preg_replace("/[^a-z0-9\._-]+/i", '-', $graphtitle); // Replace special characters with "-"
    } else if (isset($_POST['graphformat']) && $_POST['graphformat']=="external1") {
      $array=explode(":", $_POST['graphname'], 2);
      $graphtitle = trim($array[1]);
      $array = explode("(", $graphtitle, 2);
      $graphtitle = preg_replace("/[^a-z0-9\._-]+/i", '-', $array[0]);
      $graphname = $graphtitle;
    } else { // external2
      $array=explode(":", $_POST['graphname'], 2);
      $graphtitle = preg_replace("/[^a-z0-9\._-]+/i", '-', trim($array[0]));
      $graphname = $graphtitle;
    }

    // Build the output graph file name
    $randomstring = generateRandomString();
    $graphname = date("Y-m-d-H-i-s", $start)."--".date("Y-m-d-H-i-s", $end)."--".$graphname."--".$randomstring;
    $csvname = $graphname.".csv";
    $graphname .= ".png";

    if (isset($_POST['adjustgmt'])) {
      $gmt_start = $start + 3600;
    }

    $days_this_month = date("t", $gmt_start);
    $samples_this_month = $days_this_month * 24 * 12;
/*
    $rrd_max_cmd = "$rrdtool graph /dev/null ".
                "--imgformat=PNG ".
                "--start=$cmdstart ".
                "--end=$cmdend ".
                "--title='Title' ".
                "--rigid ".
                "--base=1000 ".
                "--height=120 ".
                "--width=$samples_this_month ".
                "--alt-autoscale-max ".
                "--lower-limit=0 ".
                "COMMENT:\"From ".date("Y-m-d H", $start)."\:".date("i", $start)."\:".date("s", $start).
                " to ".date("Y-m-d H", $end)."\:".date("i", $end)."\:".date("s", $end)."\c\" ".
                "COMMENT:\" \c\" ".
                "--vertical-label='bits per second' ".
                "--slope-mode ".
                "--font TITLE:10: ".
                "--font AXIS:8: ".
                "--font LEGEND:7: ".
                "--font UNIT:8: ".
                "DEF:in=\"$rrd\":traffic_in:MAX ".
                "DEF:out=\"$rrd\":traffic_out:MAX ".
                "VDEF:inbytesavg=in,AVERAGE ".
                "VDEF:outbytesavg=out,AVERAGE ".
                "CDEF:inbytesmod=in,UN,inbytesavg,in,IF ".
                "CDEF:outbytesmod=out,UN,outbytesavg,out,IF ".
                "CDEF:speedin=in,8,* ".
                "CDEF:speedout=out,8,* ".
                "VDEF:intotal=inbytesmod,TOTAL ".
                "VDEF:outtotal=outbytesmod,TOTAL ".
                "AREA:speedin#00CF00FF:\"Inbound\" ".
                "GPRINT:speedin:LAST:\"Current\:%8.4lf %s\" ".
                "GPRINT:speedin:AVERAGE:\"Average\:%8.4lf %s\" ".
                "GPRINT:speedin:MAX:\"Maximum\:%8.4lf %s\"  ".
                "GPRINT:intotal:\"Total In\:%8.4lf %s\" ".
                "COMMENT:\" \c\" ".
                "LINE1:speedout#002A97FF:\"Outbound\" ".
                "GPRINT:speedout:LAST:\"Current\:%8.4lf %s\" ".
                "GPRINT:speedout:AVERAGE:\"Average\:%8.4lf %s\" ".
                "GPRINT:speedout:MAX:\"Maximum\:%8.4lf %s\" ".
                "GPRINT:outtotal:\"Total Out\:%8.4lf %s \c\" ".
                "COMMENT:\" \c\" ".
                "HRULE:$ninetyfifthbps#FF0000FF:\"95th Percentile\" ".
                "COMMENT:\"($ninetyfifthmbps mbit in+out)\c\" ".
                "PRINT:intotal:\"%8.2lf%SBs In\" ".
                "PRINT:outtotal:\"%8.2lf%SBs Out\" ".
                "PRINT:speedin:AVERAGE:\"%8.2lf%sbps In\" ".
                "PRINT:speedout:AVERAGE:\"%8.2lf%sbps Out\" ".
                "PRINT:speedin:MAX:\"%8.2lf%sbps In\" ".
                "PRINT:speedout:MAX:\"%8.2lf%sbps Out\" ";

    exec ($rrd_max_cmd, $max_cmdout);
*/
    $rrdcmd = "$rrdtool graph $tmpfolder/$graphname ".
                "--imgformat=PNG ".
                "--start=$cmdstart ".
                "--end=$cmdend ".
                "--title='$graphtitle' ".
                "--rigid ".
                "--base=1000 ".
                "--height=120 ".
                "--width=$samples_this_month ".
                "--alt-autoscale-max ".
                "--lower-limit=0 ".
                "COMMENT:\"From ".date("Y-m-d H", $start)."\:".date("i", $start)."\:".date("s", $start).
                " to ".date("Y-m-d H", $end)."\:".date("i", $end)."\:".date("s", $end)."\c\" ".
                "COMMENT:\" \c\" ".
                "--vertical-label='bits per second' ".
                "--slope-mode ".
                "--font TITLE:10: ".
                "--font AXIS:8: ".
                "--font LEGEND:7: ".
                "--font UNIT:8: ".
                "DEF:in=\"$rrd\":traffic_in:MAX ".
                "DEF:out=\"$rrd\":traffic_out:MAX ".
                "VDEF:inbytesavg=in,AVERAGE ".
                "VDEF:outbytesavg=out,AVERAGE ".
                "CDEF:inbytesmod=in,UN,inbytesavg,in,IF ".
                "CDEF:outbytesmod=out,UN,outbytesavg,out,IF ".
                "CDEF:speedin=in,8,* ".
                "CDEF:speedout=out,8,* ".
                "VDEF:intotal=inbytesmod,TOTAL ".
                "VDEF:outtotal=outbytesmod,TOTAL ".
                "AREA:speedin#00CF00FF:\"Inbound\" ".
                "GPRINT:speedin:LAST:\"Current\:%8.2lf %s\" ".
                "GPRINT:speedin:AVERAGE:\"Average\:%8.2lf %s\" ".
                "GPRINT:speedin:MAX:\"Maximum\:%8.2lf %s\"  ".
                "GPRINT:intotal:\"Total In\:%8.2lf %s\" ".
                "COMMENT:\" \c\" ".
                "LINE1:speedout#002A97FF:\"Outbound\" ".
                "GPRINT:speedout:LAST:\"Current\:%8.2lf %s\" ".
                "GPRINT:speedout:AVERAGE:\"Average\:%8.2lf %s\" ".
                "GPRINT:speedout:MAX:\"Maximum\:%8.2lf %s\" ".
                "GPRINT:outtotal:\"Total Out\:%8.2lf %s \c\" ".
                "COMMENT:\" \c\" ".
                "HRULE:$ninetyfifthbps#FF0000FF:\"95th Percentile\" ".
                "COMMENT:\"($ninetyfifthmbps mbit in+out)\c\" ".
                "PRINT:intotal:\"%8.2lf%SBs In\" ".
                "PRINT:outtotal:\"%8.2lf%SBs Out\" ".
                "PRINT:speedin:AVERAGE:\"%8.2lf%sbps In\" ".
                "PRINT:speedout:AVERAGE:\"%8.2lf%sbps Out\" ".
                "PRINT:speedin:MAX:\"%8.2lf%sbps In\" ".
                "PRINT:speedout:MAX:\"%8.2lf%sbps Out\" ";

    exec ($rrdcmd, $cmdout);

    $csvcmd = "$rrdtool fetch --start=$cmdstart --end=$cmdend $rrd MAX | grep -Ev 'traffic|^$'";
    // The grep is to remove the first line of rrdtool output which is column headers and second line which is a blank line.
    exec ($csvcmd, $csvout);

    $csvdata = array();
    $csvdata[0] = array("epoch", "traffic_in", "traffic_out");
    for($i = 0; $i < sizeof($csvout); $i++) {
         $j = $i + 1;
         $csvdata[$j] = preg_split('/ /', $csvout[$i]);
         // Remove the colom ':' character from the epoch output
         $csvdata[$j][0] = str_replace(':', '', $csvdata[$j][0]);
    }

    $fp = fopen($tmpfolder."/".$csvname, 'w');
    foreach ($csvdata as $fields) {
        fputcsv($fp, $fields);
    }
    fclose($fp);


    echo "<b>Peak</b>: ".$cmdout[5].", ".$cmdout[6]."<br/>\n";
    echo "<b>95th% Traffic</b>: ".$ninetyfifthmbps."Mbps <br/>\n";
    echo "<b>Average</b>: ".$cmdout[3].", ".$cmdout[4]."<br/>\n";
    echo "<b>Transferred</b>: ".$cmdout[1].", ".$cmdout[2]." <br/>\n";
    echo "<img src=\"$rooturl/$httptmp/$graphname\"/><br/>\n";
    echo "<a href=\"$rooturl/$httptmp/$csvname\">CSV File</a><br/>\n";
    echo "<a href=\"javascript:toggleDebug('$randomstring');\">Toggle debug</a><br/>\n";
    echo "<pre id=\"$randomstring\" style=\"width: 600px; white-space: pre-wrap; word-wrap: break-word; display: none;\">".
         "<a href=\"".$rooturl."/graph.php?action=zoom&local_graph_id=".$_POST['graphid']."&rra_id=0&view_type=tree&graph_start=".
         $start."&graph_end=".$end."\" target=\"_blank\">Cacti View >></a> </br/>\n".
         $rrdcmd."</br>\n".
         $csvcmd."</pre></br></br>\n\n";


    // Clean up
    exec("rm $rrdtmpfile");
    exec("rm $rrdtmpfile"."_max");
    exec("rm $rrdtmpfile"."_max_sorted");
    exec("rm $rrdtmpfile"."_max_sorted_trim");

    // max_cmdout:
    // 0 = graph resolution
    // 1 = bytes in
    // 2 = bytes out
    // 3 = avg in
    // 4 = avg out
    // 5 = max in
    // 6 = max out

    return array ($graphname, $csvname, $ninetyfifthmbps, $cmdout[5], $cmdout[6], $cmdout[3], $cmdout[4]);

}


if(isset($_POST['action']) && $_POST['action']=="report") {

  // Grab the rrd file path for the posted data source 
  $sql = "SELECT DISTINCT rrd_path from `poller_item` WHERE host_id = '".$_POST['hostid']."' AND local_data_id = '".$_POST['sourceid'].
         "' LIMIT 0,1";
  $db = mysql_select_db("cacti");
  $result = mysql_query($sql);
  if(!$result || mysql_num_rows($result)!=1) {
   die("Couldn't find rrd path for data source in MySQL DB : ".mysql_error());
  }
  $rrd_path=mysql_fetch_assoc($result);

  // We are generating stats on whole month periods
  if(isset($_POST['reportperiod']) && $_POST['reportperiod']=="monthly") {
    if(!isset($_POST['monthlystartepoch']) || $_POST['monthlystartepoch']=="" || !isset($_POST['monthlyendepoch']) || $_POST['monthlyendepoch']=="") {
      echo "Valid start and end dates are required<br>";
      die();
    }
    $startMonth = $_POST['monthlystartepoch'];
    $endMonth = $_POST['monthlyendepoch'];
    $curMonth = $startMonth;
    $allMonths = array();
    $allMonthsMax = array();
    $graphs = array();
    while($curMonth<$endMonth) {
      $datestart = $curMonth;
      $dateend = strtotime(date("Y-m-t H:i:s", $curMonth+86100)); 
      // 86100 seconds is 23h;55m;00s so that puts us just before midnight
      // on the last day of the month, because date("t") provides the last day
      // of the month provided
      echo "<b>From</b>: ".date("Y-m-d H:i:s", $datestart)." (".$datestart.")</br>\n".
      "<b>To:</b> ".date("Y-m-d H:i:s", $dateend)." (".$dateend.")</br>\n";
      // We call genMaxth() and grab the name of the graph file created
      $results = genMax($datestart, $dateend, $rrd_path['rrd_path']);
      array_push($allMonths, date("Y-m-d H:i:s", $datestart), date("Y-m-d H:i:s", $dateend), $results[2], $results[3], $results[4], $results[5], $results[6]);
      array_push($graphs, $results[0]); // Graph file name
      array_push($graphs, $results[1]); // CSV file name

      // Let also generate the stats for each month using the RRD tool MAXIMUM CF,
      // to be more accurate than those shown on a graph:

      $curMonth = strtotime("+1 month", $curMonth);
    }

    if (isset($_POST['graphformat']) && $_POST['graphformat']=="internal") {
      $array=explode("|", $_POST['hostname'], 2);
      $archive = trim($array[0]);
    } else if (isset($_POST['graphformat']) && $_POST['graphformat']=="internal1") {
      $array=explode(":", $_POST['graphname'], 2);
      $archive = trim($array[1]);
      $array = explode("(", $archive, 2);
      $archive = preg_replace("/[^a-z0-9\._-]+/i", '-', $array[0]);
    } else { // external2
      $array=explode(":", $_POST['graphname'], 2);
      $archive = preg_replace("/[^a-z0-9\._-]+/i", '-', trim($array[0]));
    }

    $randomstring = generateRandomString();
    $summaryfile = date("Y-m-d-i-H-i-s", $startMonth)."--".date("Y-m-d-i-H-i-s", $endMonth)."--".$archive."--".$randomstring.".txt";
    $handle_out = fopen("$tmpfolder/$summaryfile", "w");

    fwrite($handle_out, "Summary:\n");
    echo "<b>Summary</b></br>\n";
    echo "<ul style=\"list-style-type: none; list-style: none;\">\n";
    $i=0;
    while($i < count($allMonths)) {
      echo "<li><b>Date</b>: ".$allMonths[$i]." to ".$allMonths[$i+1]." <b>95th</b>: ".$allMonths[$i+2]."Mbps ".
           "<b>Peak</b>: ".$allMonths[$i+3]." ".$allMonths[$i+4]." <b>Average</b>: ".$allMonths[$i+5]." ".$allMonths[$i+6]."</li>\n";
           
      fwrite($handle_out, "Date: ".$allMonths[$i]." to ".$allMonths[$i+1]." 95th: ".$allMonths[$i+2]."Mbps Peak: ".$allMonths[$i+3].
                          " ".$allMonths[$i+4]." Average: ".$allMonths[$i+5]." ".$allMonths[$i+6]."\n");
      $i+=7;
    }
    echo "</ul>\n";
    fwrite($handle_out, "\n");
    fclose($handle_out);

    $zipname = date("Y-m-d-i-H-i-s", $startMonth)."--".date("Y-m-d-i-H-i-s", $endMonth)."--".$archive."--".$randomstring.".zip";
    $cmd = "cd $tmpfolder && zip $zipname $summaryfile";
    foreach ($graphs as $value) {
      $cmd = $cmd." $value";
    }
    exec($cmd);
    echo "<a href=\"$rooturl/$httptmp/$zipname\">Download all Graphs and CSVs</a>\n";

  // We are generating stats for a specific one off period
  } else if (isset($_POST['reportperiod']) && $_POST['reportperiod']=="customepoch") {
    $datestart = $_POST['startepoch'];
    $dateend = $_POST['endepoch'];
    echo "<b>From</b>: ".date("Y-m-d H:i:s", $datestart)." (".$datestart.")<br>".
    "<b>To:</b> ".date("Y-m-d H:i:s", $dateend)." (".$dateend.")<br>";
    gen95th($datestart, $dateend, $rrd_path['rrd_path']);

  }

}

?>
</div>
<p style="color:#CCCCCC; font-size:small; font-family:sans-serif;">A shitty plugin by James Bensley, email <a href="mailto:jwbensley@gmail.com">jwbensley@gmail.com</a> for help.</p>
</body>
</html>

